/*
 * pTest.java
 *
 * Copyright(c) 2001, Particle Corp.
 */

/**
 * Class to test pThreadPool
 *
 * @author Alex S.
 * @version v0.0.1
 */
public class pTest implements pThreadPoolWorkListener {

    /**
     * workhorse function (part of pThreadPoolWorkListener interface)
     *
     * @param o The object we passed to pThreadPool controller.
     */
    public void performWork(Object o){
        Integer integer = (Integer)o;
        System.out.println("entered: "+Thread.currentThread().toString());
        try{    // perform the "work"...
            Thread.sleep(integer.intValue());
        }catch(InterruptedException e){
            e.printStackTrace();
        }
        System.out.println("exited: "+Thread.currentThread().toString());
    }

    /**
     * main test
     */
    public static void main(String[] args) throws Throwable {
        // create a thread pool with 50 threads and point it to our class to do work.
        pThreadPool pool = new pThreadPool(50,new pTest());

        // give it 100 items to work with...
        for(int i=0;i<100;i++)
            pool.insert(new Integer((int)(10000*Math.random())));
    }
}

